
void LoadEEPROM(){
  // ********************************************* //
  // Achtung hier wirds Tricky... In dieser Sektion lesen wir default values aus dem EEPROM in unseren Speicher.
  // Wer nicht weis was Hier passiert sollte es nicht ändern!!!
  if(EEPROM.read(0)!=42){  // Schau nach ob schonmal was im EEPROM Stand. Warum prüfen auf 42? 42 ist die Antwort auf alle Fragen!
    EEPROM.updateInt(2,int(Water_Temp*10) );
    
    EEPROM.updateInt(4,int(duenger1*100) );
    EEPROM.updateInt(6,int(duenger2*100) );
    EEPROM.updateInt(8,int(duenger3*100) );
    EEPROM.updateInt(10,int(duenger4*100) );
    EEPROM.updateInt(12,int(duenger5*100) );
    
    EEPROM.updateFloat(14,d1Time );
    EEPROM.updateFloat(16,d2Time );
    EEPROM.updateFloat(18,d3Time );
    EEPROM.updateFloat(20,d4Time );
    EEPROM.updateFloat(22,d5Time );
    
    EEPROM.updateBlock(24,light_channels);
    
    // Das waren ale Standart Vars. Ab hier könnt Ihr eure Speichern.
    EEPROM.updateFloat(37,d2Time1 );
    
    EEPROM.updateInt(0,42 );
    
  }else{
    Water_Temp = float(EEPROM.readInt(2)/10);
    
    duenger1 = float(EEPROM.readInt(4)/100);
    duenger2 = float(EEPROM.readInt(6)/100);
    duenger3 = float(EEPROM.readInt(8)/100);
    duenger4 = float(EEPROM.readInt(10)/100);
    duenger5 = float(EEPROM.readInt(12)/100);
    
    d1Time= EEPROM.readFloat(14);
    d2Time= EEPROM.readFloat(16);
    d3Time= EEPROM.readFloat(18);
    d4Time= EEPROM.readFloat(20);
    d5Time= EEPROM.readFloat(22);
    

    
    // Das waren alle Standart Vars. Ab hier könnt Ihr eure Laden.
    d2Time1= EEPROM.readFloat(37);
  }
}

int keypad(){
 
  // Eingaben Tastenfeld
	key = 0;
	//  adc_key_in = analogRead(0);
	keypad_in = analogRead(A0);
	//  key = get_key(adc_key_in);
	key = get_key(keypad_in);
	if (key != oldkey){
		keypad_in = analogRead(A0);
		Serial.println (keypad_in);
		delay(50);
		//	key = get_key(adc_key_in);
		key = get_key(keypad_in);
		if (key != oldkey){
			//Serial.println (keypad_in);
			//lcd1.setCursor(16, 3);
			//lcd1.print(keypad_in);
			oldkey = key;
                switch(key){
                  case KEYPAD01:
  				Serial.println (" KEYPAD01 ");
                                  if(autoMode==1){
                                    autoMode=0;
                                    ManuallightLevel=DaylightLevel;
                                    analogWrite(LCD_BL,255);
                                  }
                                  ManuallightLevel=ManuallightLevel+1;
                                  if(ManuallightLevel>99){
                                    ManuallightLevel=100;
                                  }
                                  setLight(ManuallightLevel);
                                  if(digitalRead(RELAY2)==HIGH){
                                    digitalWrite(RELAY2,LOW);
                                  }
                    break;
                  case KEYPAD11:
  				Serial.println (" KEYPAD11 ");
                                  if(autoMode==0){
                                    autoMode=1;
                                    setLight(0);
                                    analogWrite(LCD_BL,int(DaylightLevel*2.55));
                                  } 
                    break;
                  case KEYPAD21:
                      Serial.println (" KEYPAD21 ");
                      if(autoMode==1){
                          autoMode=0;
                          ManuallightLevel=DaylightLevel;
                          analogWrite(LCD_BL,255);
                      }
                      ManuallightLevel=ManuallightLevel-1;
                      if(ManuallightLevel<1){
                          ManuallightLevel=0;
                      }
                      setLight(ManuallightLevel);
                                
                    break;
                  case KEYPAD02:
                      Serial.println (" KEYPAD02 ");
                    break;
                  case KEYPAD03:
                      Serial.println (" KEYPAD03 ");
                      if(menudeep!=0){
                        menulevel[menudeep]-=1;
                      }
                    break;
                  case KEYPAD04:
                      Serial.println (" KEYPAD04 ");

                    break;
                  case KEYPAD12:
                      Serial.println (" KEYPAD12 ");
                      if(menudeep!=0){
                        lcd1.clearLine(menudeep);
                        menudeep-=1;
                        menulevel[menudeep]=1;
                      }
                    break;
                  case KEYPAD13:
				  
                      Serial.println (" KEYPAD13 ");
                      if(menudeep==0){
                        lcd1.clear();
                        menudeep=1;
                        menulevel[0]=1;
                      }
                    break;
                  case KEYPAD14:
                      Serial.println (" KEYPAD14 ");
                      if(menudeep!=0){
                        menulevel[menudeep]=1;
                        if(menudeep<3){
                          menudeep+=1;
                        }
                      }

                    break;
                  case KEYPAD22:
                      Serial.println (" KEYPAD22 ");
                    break;
                  case KEYPAD23:
                      Serial.println (" KEYPAD23 ");
                      if(menudeep!=0){
                        menulevel[menudeep-1]+=1;
                      }
                    break;
                  case KEYPAD24:
                      Serial.println (" KEYPAD24 ");
                  }
              }
	}
}
  

int get_key(unsigned int input)
{
  
  int k;
  for (k = 0; k < NUM_KEYPAD; k++)
  {
    if (input <=keypad_val[k] )  // adc_key_val[k]
      return k;
  }

  if (k >= NUM_KEYPAD)
    k = -1;

  return k;
}

String showString (PGM_P s) {
  char c;
  while ((c = pgm_read_byte(s++)) != 0)
return &c;
}

void Luefter(double temp){
          Serial.println("Temp");
          Serial.println(temp);
  if(temp>28){
    for( int i=0;i <  4; i++){
      analogWrite(DIM_C[i], 255);
      }    
  }else if(temp<26){
    for( int i=0;i <  4; i++){
      analogWrite(DIM_C[i], 0);
      }    
  }
}
